//+------------------------------------------------------------------+
//|              Steve Hopwood's Super_Signal auto trading robot.mq4 |
//|                                  Copyright  2009, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+


/*
int start()
void ReadSuperSignal()
void GetPositionInformation()
void SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
bool CloseOpenTrades()


*/

#property copyright "Copyright  2009, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  Nothing "No SS signal"
#define  StrongBuy "Strong Buy signal"
#define  WeakBuyExitSell "Weak Buy/exit Sell signal"
#define  StrongSell "Strong Sell signal"
#define  WeakSellExitBuy "Weak Sell/exit Buy signal"
#define  up "Up"
#define  upbutuntradable  "Up, but untradable"
#define  down "Down"
#define  downbutuntradable "Down, but untradable"
#define  undecided "No trend yet"
#define  buy "Buy"
#define  sell "Sell"

extern double  Lot=0.04;
extern int     CandleShift=1;
extern int     MagicNumber=398275;
extern string  TradeComment="SS";
extern int     StopLoss=1000;
extern int     TakeProfit=1000;
extern bool    CriminalIsECN=false;
extern int     RsiPeriod=21;
extern int     dist2           = 21;
extern int     dist1           = 14;
extern int     arrowDistance   = 10;
extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours";
extern string  Trade_Hoursi= "Use 24 hour, local time clock";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;

//These are externs in the indi, but are not needed as user inputs here.
bool           alertsOn        = true;
string         note1 = "alert all = 0",
               note2 = "buy only = 1, sell only = 2",
               note3 = "strong buy or strong sell = 3";
int            alertsOption    = 0;
bool           alertsOnCurrent = false;
bool           alertsMessage   = true;
bool           alertsSound     = true;
bool           alertsEmail     = false;



string         SignalStatus, Trend, ScreenMessage, TradeType;
int            OldBars;
double         OpenLotSize, StopLossPrice, MarketPrice;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----

   //Adjust settings for 4 digit crim
   if (Digits == 2 || Digits == 4)
   {
      StopLoss/= 10;
   }//if (Digits == 2 || Digits == 4)

      OldBars = Bars;
      Comment("Waiting for the start of a new candle");
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }


void GetPositionInformation()
{

   OpenLotSize = 0;
   TradeType = "";
   StopLossPrice = 0;
   
   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      //Find open trades unique to this chart
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         OpenLotSize+= OrderLots();
         if (OrderType() == OP_BUY) TradeType = buy;
         if (OrderType() == OP_SELL) TradeType = sell;
         if (OrderStopLoss() != 0) StopLossPrice = OrderStopLoss();
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
      
      
}//void GetPositionInformation()

  
void ReadSuperSignal()
{

      SignalStatus = Nothing;
      
      //Get trend
      //Read Rsi
      //RsiDirection = unchanged;
      double RsiVal = iRSI(NULL, PERIOD_D1, RsiPeriod, PRICE_CLOSE, 0);
      double PrevRsiVal = iRSI(NULL, PERIOD_D1, RsiPeriod, PRICE_CLOSE, 1);
      
      
            
      Trend = undecided;
      if (RsiVal > 55) Trend = up;
      if (RsiVal > 55 && RsiVal < PrevRsiVal) Trend = upbutuntradable;
      if (RsiVal < 45) Trend = down;
      if (RsiVal < 45 && RsiVal > PrevRsiVal) Trend = downbutuntradable;
      if (Trend == undecided) return;
      
      //Strong sell signal
      double MarketPrice = iCustom(NULL, 0, "Super_Signal_v3f_-_fixed_dista", dist2, dist1, arrowDistance, alertsOn, 
                       alertsOption, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, 0,CandleShift);   
   
      if (MarketPrice != EMPTY_VALUE) 
      {
         SignalStatus = StrongSell;
         return;
      }//if (MarketPrice != EMPTY_VALUE) 
   
   
      //Strong buy signal
      MarketPrice = iCustom(NULL, 0, "Super_Signal_v3f_-_fixed_dista", dist2, dist1, arrowDistance, alertsOn, 
                       alertsOption, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, 1,CandleShift);   
   
      if (MarketPrice != EMPTY_VALUE) 
      {
         SignalStatus = StrongBuy;
         return;
      }//if (MarketPrice != EMPTY_VALUE) 
   
   
      //Weak sell/exit buy signal
      MarketPrice = iCustom(NULL, 0, "Super_Signal_v3f_-_fixed_dista", dist2, dist1, arrowDistance, alertsOn, 
                       alertsOption, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, 2,CandleShift);   
   
      if (MarketPrice != EMPTY_VALUE) 
      {
         SignalStatus = WeakSellExitBuy;
         return;
      }//if (MarketPrice != EMPTY_VALUE) 
   
   
      //Weak buy/exit sell signal
      MarketPrice = iCustom(NULL, 0, "Super_Signal_v3f_-_fixed_dista", dist2, dist1, arrowDistance, alertsOn, 
                       alertsOption, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, 3,CandleShift);   
   
      if (MarketPrice != EMPTY_VALUE) 
      {
         SignalStatus = WeakBuyExitSell;
         return;
      }//if (MarketPrice != EMPTY_VALUE) 
   


}//double ReadSuperSignal()
/*
bool CloseOpenTrades()
{
   
   if (OrdersTotal() == 0) return(true);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      bool result = true;
      //Find open trades unique to this chart
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 500,CLR_NONE);
         if (result) cc++;
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
      
   return(result);

}//bool CloseOpenTrades()
*/
void SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   // Attempts to place a trade according to type, i.e.
   
   
   if (!IsTradeAllowed() ) return;
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY) col = Green;
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, 0, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, 0, col);
	   if (stop != 0)
	   {
		   if (ticket > 0)
		   bool result = OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), 0, CLR_NONE);
		   if (!result)
		   {
		       int err=GetLastError();
             Alert(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
		   }//if (!result)			  
	   }//if (Sl != 0)
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   /*
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_SELL) stype = "OP_SELL";
      err=GetLastError();
      Alert(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      OldBars=0;//Force a retry at the next tick
   }//if (ticket < 0)  
   */
}//End void SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   static int loops;
   loops++;
   
   //Trading hours
   int hour = TimeHour(TimeLocal() );
	if (end_houre < start_houre)
	{
		end_houre += 24;
	}
	
	bool ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

	// adjust for past-end-of-day cases
	// eg in AUS, USDJPY trades 09-17 and 22-06
	// so, the above check failed, check if it is because of this condition
	if (!ok2Trade && hour < 12)
	{
 		hour += 24;
		ok2Trade = (hour >= start_houre && hour <= end_houre);
		
		// so, if the trading hours are 11pm - 6am and the time is between  midnight to 11am, (say, 5am)
		// the above code will result in comparing 5+24 to see if it is between 23 (11pm) and 30(6+24), which it is...
	}


   if (!ok2Trade)
   {
      Comment("Outside trading hours");
      return;
   }//if (!ok2Trade)
   //End trading hours code
   
   
   if (CandleShift == 0) OldBars = 0;
   
   if (OldBars != Bars)
   {
      if (CandleShift == 1) Sleep(3000);
      OldBars = Bars;
      ScreenMessage="";
      GetPositionInformation();
      
      ReadSuperSignal();
      bool result;
      
      /*
      //Close open trades where necessary.
      //GetPositionInformation() leaves TradeType set.
      //Close sell trades on opposite signal
      //if ((SignalStatus == StrongBuy || SignalStatus == WeakBuyExitSell) && OpenLotSize > 0 && TradeType == sell)
      if (SignalStatus == StrongBuy && OpenLotSize > 0 && TradeType == sell)
      {
         result = CloseOpenTrades();
         if (!result) OldBars = 0;//Force a retry at next tick
      }//if ((SignalStatus == StrongBuy || SignalStatus == WeakBuyExitSell) && OpenLotSize > 0 && OrderType() == OP_SELL)
      
      //Close buy trades on opposite signal
      if (SignalStatus == StrongSell && OpenLotSize > 0 && TradeType == buy)
      {
         result = CloseOpenTrades();
         if (!result) OldBars = 0;//Force a retry at next tick
      }//if ((SignalStatus == StrongBuy || SignalStatus == WeakBuyExitSell) && OpenLotSize > 0 && OrderType() == OP_SELL)
      */
      
      //Trade into a trend after a retrace
      //Buy trades
      if (Trend == up && OpenLotSize < Lot && SignalStatus == StrongBuy)
      {
         double stop = NormalizeDouble(Ask - StopLoss * Point, Digits);
         double tp = NormalizeDouble(Ask + TakeProfit * Point, Digits);
         if (StopLossPrice != 0) stop = StopLossPrice;
         SendSingleTrade(OP_BUY, TradeComment, Lot, Ask, stop, tp);
      }//if (Trend == up && OpenLotSize < Lot)
      
      //Sell trades
      if (Trend == down && OpenLotSize < Lot && SignalStatus == StrongSell)
      {
         stop = NormalizeDouble(Bid + StopLoss * Point, Digits);
         tp = NormalizeDouble(Bid - TakeProfit * Point, Digits);
         if (StopLossPrice != 0) stop = StopLossPrice;
         SendSingleTrade(OP_SELL, TradeComment, Lot, Bid, stop, tp);
      }//if (Trend == up && OpenLotSize < Lot)
      
      
      ScreenMessage = StringConcatenate(ScreenMessage, SignalStatus, NL, "Trend is ", Trend, NL, loops, NL);
   
      Comment(ScreenMessage);   
   }//if (OldBars != Bars)
   
   
//----
   return(0);
}
//+------------------------------------------------------------------+