//+------------------------------------------------------------------+
//|        Steve Hopwood's ZigZag Swing Break auto-trading robot.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define high "High"
#define low "Low"
#define none "None"
#define up "Up"
#define down "Down"

/*
www.forexpros.com
	

void DisplayUserFeedback()
int start()
void DoesTradeExist(string symbol)
void SendSingleTrade(int type, string symbol)
void GetSwing(string symbol, int period)
bool ShouldRobotSleep(string symbol)



----Trade management----
bool CloseTrade(int ticket)


----Pairs traded----
void CleanUpInputString()
void CalculatePairsPassed()
void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 


*/


//extern string  PairsToTrade = "EURAUD,EURUSD,GBPJPY,GBPUSD,USDCHF,USDJPY";
//extern string  PairsToTrade = "EURUSD";
extern string  PairsToTrade = "AUDJPY,AUDUSD,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURUSD,GBPJPY,GBPUSD,USDCAD,USDCHF,USDJPY";
extern double  Lot = 0.01;
extern int     MagicNumber = 329859;
extern string  TradeComment="SZBO";
//extern bool    CriminalIsECN=false;
extern int     SleepAfterTradeClosesMins=60;
extern string  sls="----Atr sl & tp inputs----";
extern int     AtrPeriod=14;
extern int     AtrTimeFrame=240;
extern double  TakeProfitMultiplier=1.5;
extern double  StopLossMultiplier=1;
extern string  tfs="----Time frames in minutes----";
extern string  tfs1="D1=1440: W1=10080: MN1=40320";
extern int     TradingTimeFrame=15;
extern int     HigherTimeFrame=240;
extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours 24hr";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;
extern string  wei="----Week ending inputs----";
extern bool    FridayStopTrading=true;
extern bool    SaturdayStopTrading=false;
extern int     StopTradingHour = 12;
extern bool    TradeSundayCandle=false;
extern string  dins="----Pair display settings----";
extern bool    ShowPairsInformation=true;
extern color   PairColour=Yellow;
extern color   LongColour=Green;
extern color   ShortColour=Red;
extern double  DisplayHorizontalStart=50;
extern int     HorizontalIncrement=60;
extern double  DisplayVerticalStart=13;
extern int     VerticalIncrement=2.5;
extern int     FontSize=9;
extern string  oae="----Odds and ends----";
extern int     DisplayGapSize=30;
                                    



//Open trades\trade direction.
//bool              LongTradeExists, ShortTradeExists;
int      TicketNo;
int      NoOfTrades;

//Trading hours
bool     ClosedForFriday;
bool     ClosedForSaturday;

//Swing
double   HtfSwingHigh[], HtfSwingLow[];//Swing extremes and momentum for each pair
string   LtfSwing[], LtfMomentum[], Momentum;
double   SwingHigh, SwingLow;//Holds the value of the latest htf swings

//Pair extraction
string   InputString;//Holds the contents PairsToTrade for tidying yp etc
int      NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string   TradePair[]; //Array to hold the pairs traded by the user
int      HtfBars[],LtfBars[];

//Misc stuff
int      Decimals, OldBars;
string   ScreenMessage, Gap;
bool     RobotDisabled;
string   DisabledMessage;

//Label positions
double   horizontal, vertical;


void DisplayUserFeedback()
{

   ScreenMessage = "";
   int cc;
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading ", PairsToTrade, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment: ", TradeComment, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading time frame: ", TradingTimeFrame, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Higher time frame: ", HigherTimeFrame, NL);
   
   //if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is true ", NL);
   //else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is false ", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour start = ", start_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour end = ", end_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour start = ", start_houre, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour end = ", end_houre, NL);
   if (TradeSundayCandle) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Trading the Sunday candle", NL);
   else ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Not trading the Sunday candle", NL);
   if (FridayStopTrading) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(StopTradingHour, 2), NL);
   if (SaturdayStopTrading) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(StopTradingHour, 2), NL);
   if (ClosedForSaturday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Saturday close. Continuing to monitor open trades.", NL);
   if (ClosedForFriday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Friday close. Continuing to monitor open trades.", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "SleepAfterTradeClosesMins = ", SleepAfterTradeClosesMins, NL);
   

   Comment(ScreenMessage);
   
   
   if (ShowPairsInformation)
   {
      vertical+= 0.8;
      string Label_Name;
      int update;
      
      //Headings
      vertical = DisplayVerticalStart;
      horizontal = DisplayHorizontalStart + HorizontalIncrement* 1.5; 
     
      Label_Name = "headlabel" + "a";
      Printtxt("Htf High",Label_Name,FontSize,"Arial", LongColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
   
      Label_Name = "headlabel" + "b";
      Printtxt("Htf Low",Label_Name,FontSize,"Arial", ShortColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
         
      Label_Name = "headlabel" + "c";
      Printtxt("Momo",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
         
      Label_Name = "headlabel" + "d";
      Printtxt("Ltf Swing",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
   
      vertical+= VerticalIncrement;

      //Pair details
      for (cc = 0; cc < ArraySize(TradePair); cc++)
      {
         string symbol = TradePair[cc];
               
         int digits = MarketInfo(symbol, MODE_DIGITS);
         double ask = MarketInfo(symbol, MODE_ASK);
         double bid = MarketInfo(symbol, MODE_BID);
         
         
         horizontal = DisplayHorizontalStart * 1.5;
         
         Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
         Printtxt(symbol,Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
         horizontal+= HorizontalIncrement; 
         update++;
      
         Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
         Printtxt(DoubleToStr(HtfSwingHigh[cc], digits),Label_Name,FontSize,"Arial", LongColour,vertical,horizontal);
         horizontal+= HorizontalIncrement; 
         update++;

     
         Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
         Printtxt(DoubleToStr(HtfSwingLow[cc], digits),Label_Name,FontSize,"Arial", ShortColour,vertical,horizontal);
         horizontal+= HorizontalIncrement; 
         update++;
         

         color col = LongColour;
         if (LtfMomentum[cc] == down) col = ShortColour;
         
         if (LtfSwing[cc] != none)
         {
            Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
            Printtxt(LtfMomentum[cc],Label_Name,FontSize,"Arial", col,vertical,horizontal);
            horizontal+= HorizontalIncrement; 
            update++;
         }//if (LtfMomentum[cc] != none)


         col = LongColour;
         if (LtfSwing[cc] == low) col = ShortColour;
         
         if (LtfSwing[cc] != none)
         {
            Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
            Printtxt(LtfSwing[cc],Label_Name,FontSize,"Arial", col,vertical,horizontal);
            horizontal+= HorizontalIncrement; 
            update++;
         }//if (LtfSwing[cc] != none)
         

         
         
         
         vertical+= VerticalIncrement;
         
      }//for (int cc = 0; cc < ArraySize(TradePair); cc++)
      
   
   }//if (ShowPairsInformation)
   
   
}//End void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 329859)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 329859." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits high, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits high - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)     
      
   }//if (!IsDemo)
   
   
   //Amend inputs to cater for different broker digits
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   if (dig == 2 || dig == 4)
   {   
      
   }//if (dig = 3)
   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   
   //These two arrays are used to make the robot look for trading opps only at the start of each new candle
   double iNew3 = ArrayResize(HtfBars, NoOfPairs);//Higher time frame bars
   double iNew4 = ArrayResize(LtfBars, NoOfPairs);//Trading chart
   string sNew1 = ArrayResize(HtfSwingHigh, NoOfPairs);//Trend based on higher tf
   string sNew2 = ArrayResize(HtfSwingLow, NoOfPairs);//Trend based on higher tf
   string sNew3 = ArrayResize(LtfMomentum, NoOfPairs);//Momentum established by a break of htf hi-lo
   string sNew4 = ArrayResize(LtfSwing, NoOfPairs);//Ltf swing
   
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         LastIndex = Index+1;
         //HtfBars[cc] = iBars(TradePair[cc], 0);         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }
   
   
      
   Comment(".........Waiting for a tick");
   DisplayUserFeedback();
   
   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {

    Comment("");
    ObjectsDeleteAll(0, OBJ_LABEL);
    return(0);

  }
  
//+------------------------------------------------------------------+
//| expert GetPosition function                                      |
//+------------------------------------------------------------------+




void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   NoOfPairs = 0;
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()


void DoesTradeExist(string symbol)
{
   TicketNo = 0;
   
   
   if (OrdersTotal() == 0) return; //nothing to do
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol) 
      {
         
         TicketNo = OrderTicket();
         return;
         
      }//if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol)       
   }//for (int cc = OrdersTotal() - 1; cc >= 0, cc--)  
   
}//End void DoesTradeExist(string symbol)



void SendSingleTrade(int type, string symbol)
{
   // Attempts to place a trade according to type, i.e.
   // 0 = OP_BUY
   // 1 = OP_SELL
   
   
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);
   
   
   double StopLoss,TakeProfit, TradePrice;
   double AtrVal = iATR(symbol, AtrTimeFrame, AtrPeriod, 0);
   
   
   
   if (type == OP_BUY)
   {
      TradePrice = ask;
      StopLoss = NormalizeDouble(TradePrice - (AtrVal * StopLossMultiplier), digits);
      TakeProfit = NormalizeDouble(TradePrice + (AtrVal * TakeProfitMultiplier), digits);
   }//if (type == 4)

   
   
   
   if (type == OP_SELL)
   {
      TradePrice = bid;
      StopLoss = NormalizeDouble(TradePrice + (AtrVal * StopLossMultiplier), digits);
      TakeProfit = NormalizeDouble(TradePrice - (AtrVal * TakeProfitMultiplier), digits);
   }//if (type == 4)
   
   
   
   int ticket = OrderSend(symbol,type, Lot, TradePrice, 0, StopLoss, TakeProfit, TradeComment, MagicNumber,0, CLR_NONE);
   if (ticket < 0)
   {
      int err=GetLastError();
      if (err == 130) return;
      Alert("ZigZag Swing Break ", symbol, " ", type," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      Sleep(1000);
      return(false);
   }//if (ticket < 0)
   else Sleep(5000);//5 second   
   
   
   
}//End void SendSingleTrade(int type, string symbol)

/*
bool CloseTrade(int ticket)
{
   //Attempts to close the trade. Returns true if succeeds, else false
   
   if (!OrderSelect(ticket, SELECT_BY_TICKET) ) return;
   bool result = OrderClose(ticket, OrderLots(), OrderClosePrice(), 1000, CLR_NONE);
   if (result) return(true);
   else return(false);

}//End bool CloseTrade(int ticket)
*/
void GetSwing(string symbol, int period)
{
   //Detects a swing high or low
    int k = 0;
    double z1 = 0;
    double z2 = 0;
    double z3 = 0;
    datetime t1,t2,t3;
    
    double val, highest, lowest;
    highest = -1000000;
    lowest = 1000000;
    
    while(true)
    {
      if(k == iBars(symbol, period)) break;
      double zz = iCustom(symbol, period, "Zigzag", 12,5,3, 0, k);
      if(zz!=0)
      {
        z1 = z2; z2=z3; z3=zz;
        t1 = t2; t2=t3; t3=iTime(symbol, period, k);
        val = iHigh(symbol, period, k);
        if (val > highest) highest = val;
        val = iLow(symbol, period, k);
        if (val < lowest) lowest = val;        
      }
      if(z1>0) break;
      k++;
    }
   //z2 is the recent swing that occurred at candle time t2
   //z3 is the previous swing that occurred at candle time t3
   Momentum = none;
   if (z2 < z3)
   {
      SwingLow = z2;     
      SwingHigh = z3;
      if (lowest < SwingLow) Momentum = down;
   }//if (t2 > t3)
   
   if (z2 > z3)
   {
      SwingLow = z3;     
      SwingHigh = z2;
      if (highest > SwingHigh) Momentum = up;
   }//if (t2 > t3)
   
   

   


}//End void GetSwing(string symbol, int period)

void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + horizontal);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * vertical);
   
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {

bool ShouldRobotSleep(string symbol)
{
   // Checks the history list to find a closed trade.
   // If one exists, checks to see if it closed more than SleepAfterTradeClosesMins.
   // Returns false (sleep not needed) if so, else true (sleep needed)
   
   if (OrdersHistoryTotal() == 0) return(false);// No history trades, so sleep clearly not needed
   
   for(int cnt = 0; cnt < OrdersHistoryTotal(); cnt++)
   {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)) continue;
      {       
         if (OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         {
            int TimePassed = (TimeCurrent() - OrderCloseTime()) / 60;
            if (TimePassed < SleepAfterTradeClosesMins) return(true);//Robot should sleep
         }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)            
      }//if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
   }//for(int cnt=0; cnt<OrdersHistoryTotal(); cnt++)

   //Got this far, so sleep not needed
   return(false);

}//End bool ShouldRobotSleep(string symbol)


//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
   
   bool result;
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )
   
   //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //Check Friday close
  if (FridayStopTrading)
  {
     ClosedForFriday = false;
     if (TimeHour(TimeLocal() ) >= StopTradingHour && TimeDayOfWeek(TimeLocal() ) == 5)
     {
        ClosedForFriday = true;
        DisplayUserFeedback();
        return;
     }//if (TimeHour(TimeLocal()) >= StopTradingHour && DayOfWeek() == 5)
  }//if (FridayStopTrading)
     
  //Check Saturday close for Aitipodeans
  if (SaturdayStopTrading)
  {
     ClosedForSaturday = false;
     if (TimeHour(TimeLocal() ) >= StopTradingHour && TimeDayOfWeek(TimeLocal() ) == 6)
     {
        ClosedForSaturday = true;
        DisplayUserFeedback();
        return;
     }//if (TimeHour(TimeLocal()) >= StopTradingHour && DayOfWeek() == 5)
  }//if (Saturday)

  //Sunday candle
  if (TimeDayOfWeek(TimeLocal() ) == 0 && !TradeSundayCandle) return;   

   
   //Trading hours
   bool TradeHour = false;
   int lhour = TimeHour(TimeLocal() );
   if ( (lhour >= start_hourm && lhour < end_hourm) || (lhour >= start_houre && lhour < end_houre) ) TradeHour = true;
   if (!TradeHour)
   {
      Comment(Gap, "Trading suspended - outside trade hours. Continuing to monitor open trades.");
      return;
   }//if (!TradeHour)
   //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


    //Look for trading opportunities
    for(int cc = 0; cc < ArraySize(TradePair); cc++)
    {

      string symbol = TradePair[cc];//Does nothing more than make typing easier

 
      
      
      
      
      
       if (!IsTradeAllowed())
       {
            Comment("Trading disabled by the criminal pillock. Please wait for him to get out of bed.");
            return;
       }//if (!IsTradeAllowed)
       
       
        
       if(iClose(symbol,0,0) > 0)
       {      
            
            //Look for higher tf swing
            if (HtfBars[cc] != iBars(TradePair[cc], HigherTimeFrame) )
            {
               double OldHigh = HtfSwingHigh[cc];
               double OldLow = HtfSwingLow[cc];
               GetSwing(symbol, HigherTimeFrame);
               HtfSwingHigh[cc] = SwingHigh;
               HtfSwingLow[cc] = SwingLow;
               //Ltf momentum needs re-setting following a new swing hi or low
               if (HtfSwingHigh[cc] != OldHigh || HtfSwingLow[cc] != OldLow) LtfMomentum[cc] = "";
               HtfBars[cc] = iBars(TradePair[cc], HigherTimeFrame);
            }//if (HtfBars[cc] != iBars(TradePair[cc], 0) )
            
            //Check trading time frame for a swing change
            if (LtfBars[cc] != iBars(TradePair[cc], TradingTimeFrame) )
            {
               LtfSwing[cc] = none;
               if(iFractals(symbol, TradingTimeFrame, MODE_LOWER,3)!=0) LtfSwing[cc] = low;
               if(iFractals(symbol, TradingTimeFrame, MODE_UPPER,3)!=0) LtfSwing[cc] = high;
               LtfBars[cc] = iBars(TradePair[cc], TradingTimeFrame);
            }//if (LtfBars[cc] != iBars(TradePair[cc], TradingTimeframe) )
            
            RefreshRates();
            double ask = MarketInfo(symbol, MODE_ASK);
            double bid = MarketInfo(symbol, MODE_BID);
            double point = MarketInfo(symbol, MODE_POINT);
            double digits = MarketInfo(symbol, MODE_DIGITS);

            if (LtfMomentum[cc] == none || LtfMomentum[cc] == "")
            {
               if (ask > HtfSwingHigh[cc]) LtfMomentum[cc] = up;
               if (bid < HtfSwingLow[cc]) LtfMomentum[cc] = down;
            }//if (LtfMomentum[cc] == none || LtfMomentum[cc] == "")
            
            if (IsTradeAllowed() )
            {                    
               
/*               //Close long trades in a rising trend after a lower tf swing high.
               if (LtfMomentum[cc] == up && LtfSwing[cc] == high)
               {
                  DoesTradeExist(symbol);
                  result = true;
                  if (TicketNo > -1)
                  {
                     OrderSelect(TicketNo, SELECT_BY_TICKET);
                     if (OrderType() == OP_BUY) result = CloseTrade(TicketNo);
                     if (!result) continue;//Force a retry attempt before sending a trade
                  }//if (TicketNo > -1)
               }//if (Trend[cc] == up && Swing[cc] == high)
               
               
               //Close short trades in a falling trend after a lower tf swing low
               if (LtfMomentum[cc] == down && LtfSwing[cc] == low)
               {
                  DoesTradeExist(symbol);
                  result = true;
                  if (TicketNo > -1)
                  {
                     OrderSelect(TicketNo, SELECT_BY_TICKET);
                     if (OrderType() == OP_SELL) result = CloseTrade(TicketNo);
                     if (!result) continue;//Force a retry attempt before sending a trade
                  }//if (TicketNo > -1)
               }//if (Trend[cc] == up && Swing[cc] == high)
               
               //Close short trades after an up momentum change to down
               if (LtfMomentum[cc] == up)
               {
                  DoesTradeExist(symbol);
                  result = true;
                  if (TicketNo > -1)
                  {
                     OrderSelect(TicketNo, SELECT_BY_TICKET);
                     if (OrderType() == OP_SELL) result = CloseTrade(TicketNo);
                     if (!result) continue;//Force a retry attempt before sending a trade
                  }//if (TicketNo > -1)
               }//if (Trend[cc] == up)
               
               //Close long trades after a down momentum change to up
               if (LtfMomentum[cc] == down)
               {
                  DoesTradeExist(symbol);
                  result = true;
                  if (TicketNo > -1)
                  {
                     OrderSelect(TicketNo, SELECT_BY_TICKET);
                     if (OrderType() == OP_BUY) result = CloseTrade(TicketNo);
                     if (!result) continue;//Force a retry attempt before sending a trade
                  }//if (TicketNo > -1)
               }//if (Trend[cc] == up)
               
*/  
               //Send a new sell into a short trend after a ltf swing high
               if (LtfMomentum[cc] == down && LtfSwing[cc] == high && bid < iOpen(symbol, TradingTimeFrame, 0) )
               {
                  DoesTradeExist(symbol);
                  if (TicketNo > 0 && OrderType() == OP_SELL) continue;//Trade already exists
                  if (!TicketNo == 0)
                  {
                     bool SendToSleep = ShouldRobotSleep(symbol);// Compares closure time of history trade with current time, 
                                                           // returning true for sleep or false. Will return false if no history trades
                     if (SendToSleep)
                     {
                        continue;
                     }//if (SendToSleep)
                  }//if (!TicketNo < 0)
                      
                  SendSingleTrade(OP_SELL, symbol);
               }//if (Trend[cc] == down && Swing[cc] == high && bid < iOpen(symbol, TradingTimeFrame, 0) )
      
               //Send a new buy into a long trend after a ltf swing low
               if (LtfMomentum[cc] == up && LtfSwing[cc] == low && ask > iOpen(symbol, TradingTimeFrame, 0) )
               {  
                  DoesTradeExist(symbol);
                  if (TicketNo > 0 && OrderType() == OP_BUY) continue;//Trade already exists
                  if (!TicketNo == 0)
                  {
                     SendToSleep = ShouldRobotSleep(symbol);// Compares closure time of history trade with current time, 
                                                           // returning true for sleep or false. Will return false if no history trades
                     if (SendToSleep)
                     {
                        continue;
                     }//if (SendToSleep)
                  }//if (!TicketNo < 0)
                  SendSingleTrade(OP_BUY, symbol);
               }//if (Trend[cc] == up && Swing[cc] == low && ask > iOpen(symbol, TradingTimeFrame, 0) )
               
            }//if (IsTradeAllowed)        
      
         }//if(iClose(TradePair[cc],0,0) > 0)
      
      }//for(int cc = 0; cc < ArraySize(TradePair); cc++)
    
    DisplayUserFeedback();
      
    return(0);

}//End start()


